GCP_TYPE_LOOKUP: dict = {
    "ARRAY": "ARRAY",
    "BIGINT": "BIGNUMBER",
    "BINARY": "STRING",
    "BINARYDOUBLE": "FLOAT64",
    "BINARYFLOAT": "FLOAT64",
    "BIT": "BOOL",
    "BOOLEAN": "BOOL",
    "CHAR": "STRING",
    "CURRENCY": "INT64",
    "DATE": "DATE",
    "DATETIME": "TIMESTAMP",
    "DECIMAL": "FLOAT64",
    "DOUBLE": "FLOAT64",
    "FLOAT": "FLOAT64",
    "INT": "INT64",
    "INTEGER": "INT64",
    "INTEGERTYPE": "INT64",  # to match ids-common-utils: https://github.com/ONSdigital/ids-common-utils/pull/198
    "LONG": "STRING",
    "LONGTEXT": "STRING",
    "OBJECT": "STRING",
    "NUMBER": "INT64",
    "NUMERIC": "INT64",
    "OBJECTID": "STRING",
    "SHORTTEXT": "STRING",
    "SMALLINT": "INT64",
    "STRING": "STRING",
    "TEXT": "STRING",
    "TIME": "TIME",
    "TIMESTAMP": "TIMESTAMP",
    "TINYINT": "INT64",
    "VARCHAR": "STRING",
    "REAL": "FLOAT64",
    "ARCHAR2": "STRING",
    "CLOB": "STRING",
    "ZERO-TERMINATEDBYTES": "STRING",
    "UNICODESTRING": "STRING",
    "INT32": "INT64",
    "INT8": "INT64",
    "INT16": "INT64",
    "NVARCHAR": "STRING",
    "NCHAR": "STRING",
    "NTEXT": "STRING",
    "NUMERICAL": "INT64",
}


MD_TAB_LOOKUP = {
    "change_history": "Change history",
    "change_log": "Change Log",
    "introduction": "Introduction",
    "metadata_levels": "Metadata levels",
    "instructions": "Instructions",
    "definitions_and_vocabulary": "Definitions and Vocabulary",
    "dataset_resource": "Dataset Resource",
    "dataset_series": "Dataset Series",
    "dataset_file": "Dataset File",
    "variables": "Variables",
    "codes_and_values": "Codes and Values",
    "gateway": "Gateway",
    "analyseaudit": "Analyse-Audit",
    "analyse": "Analyse",
    "manage": "Manage",
    "disseminate_da": "Disseminate (DA)",
    "disseminate_ba": "Disseminate (BA)",
    "dataset_product": "Dataset Product",
    "other_questionscomments": "Other questions-Comments",
    "dataset_seriesversion1": "Dataset Series-Version1",
    "worksheet": "worksheet",
    "domains": "Domains",
    "back_office": "Back Office",
    "lookup_values": "Lookup Values",
}


MD_V1_LOOKUP: dict = {
    "md_id": 1,
    "dataset_series": {
        "dataset_resource": "Dataset Resource",
        "dataset_series_type": "Dataset Series Type",
        "dataset_series_name": "Dataset Series Name",
        "dataset_series_description": "Dataset Series Description",
        "dataset_series_creator": "Dataset Series Creator",
        "reference_period": "Dataset Series Reference Period",
        "geographic_coverage": "Dataset Series Geographic Coverage",
        "frequency": "Dataset Series Frequency",
        "expected_date_of_first_delivery": "Expected date of first delivery",
        "expected_dates_for_future_deliveries": "Expected date(s) for future deliveries",
        "dataset_series_metadata_version_number_if_different_from_number_for_dataset_resource": "Dataset Series Metadata version number (if different from number for Dataset Resource)",
        "wave_numbertime_period_covered_survey_only": "Dataset Resource Wave number/time period covered (Survey only)",
        "manifest_file": "Manifest File",
        "links_to_online_documentation_and_other_useful_materials": "Links to online documentation and other useful materials",
        "sensitivity_status_for_dataset_series_if_different_from_that_for_dataset_resource": "Sensitivity status for Dataset Series (if different from that for Dataset Resource)",
        "security_classification_of_dataset_series": "Security classification of Dataset Series",
        "dataset_series_usage_restrictions_status": "Dataset Series Usage Restrictions status",
        "dataset_series_usage_restrictions_details": "Dataset Series Usage Restrictions details",
        "dataset_series_disclosure_restriction_status": "Dataset Series Disclosure Restriction status",
        "dataset_series_disclosure_restriction_details": "Dataset Series Disclosure Restriction details",
        "data_deal_reference_link_to_annex": "Data Deal reference (link to Annex)",
    },
    "dataset_file": {
        "dataset_series": "Dataset Series",
        "file_path_and_name": "File path and name",
        "file_version_number": "File version number",
        "file_creation_date": "File creation date",
        "file_receipt_date": "File receipt date",
        "file_format": "File format",
        "string_identifier": "String identifier",
        "file_description": "File description",
        "earliest_date": "Earliest date",
        "latest_date": "Latest date",
        "reference_period": "Reference period",
        "file_size": "File size",
        "file_size_unit": "File size unit",
        "has_structure": "Has structure",
        "is_documentation": "Is documentation",
        "documentation_type": "Documentation type",
        "is_code_list": "Is code list",
        "number_of_variables": "Number of variables",
        "number_of_records": "Number of records",
        "is_this_file_one_of_a_sequence_to_be_appended_back_together": "Is this file one of a sequence to be appended back together?",
        "number_of_header_rows": "Number of header rows",
        "number_of_footer_rows": "Number of footer rows",
        "does_this_file_contain_multiple_heterogeneous_sets_of_data": "Does this file contain multiple heterogeneous sets of data?",
        "file_with_multiple_heterogeneous_sets_of_data__details": "File with multiple heterogeneous sets of data - details",
        "is_compressed": "Is compressed?",
        "compression_type": "Compression type",
        "character_encoding": "Character encoding",
        "checksum_method_used": "Checksum method used",
        "hash_value_for_checksum": "Hash value for checksum",
        "google_cloud_platform_table_name": "Google Cloud Platform: Table Name",
        "notes": "Notes",
    },
    "variables": {
        "dataset_series": "Dataset Series",
        "dataset_file_name": "Dataset file name",
        "variable_name": "Variable name",
        "variable_label": "Variable label",
        "variable_description": "Variable description",
        "position_in_file": "Position in file",
        "personally_identifiable_information": "Personally Identifiable Information",
        "variable_data_type": "Variable data type",
        "gcp_data_type": "GCP Data Type",
        "variable_lengthprecision": "Variable length/precision",
        "variable_format": "Variable format",
        "is_primary_key": "Is Primary Key",
        "is_foreign_key": "Is Foreign Key",
        "foreign_key_file_name": "Foreign Key file name",
        "foreign_key_variable_name": "Foreign Key variable name",
        "nullability": "Nullability",
        "null_values_denoted_by": "NULL values denoted by",
        "variable_constraints": "Variable constraints",
        "applicable_business_rules": "Applicable business rules",
        "is_this_a_code": "Is this a code?",
        "is_this_a_standard_calculated_or_derived_variable": "Is this a standard, calculated, or derived variable?",
        "is_the_derived_variable_status_disclosable": "Is the derived variable status disclosable?",
        "if_a_calculated_or_derived_variable_how_is_it_calculatedderived": "If a calculated or derived variable, how is it calculated/derived?",
        "if_a_calculated_or_derived_variable_is_the_algorithmprocess_disclosable": "If a calculated or derived variable, is the algorithm/process disclosable?",
        "notes": "Notes",
    },
}

MD_V2_LOOKUP: dict = {
    "md_id": 2,
    "dataset_series": {
        "dataset_series_name": "Dataset Series Name",
        "google_cloud_platform_bigquery_table_name": "Google Cloud Platform BigQuery Table Name",
        "description": "Description",
        "reference_period": "Reference Period",
        "geographic_coverage": "Geographic Coverage",
        "frequency": "Frequency",
        "supply_type": "Supply Type",
        "wave_numbertime_period_covered_survey_only": "Wave number/time period covered (Survey only)",
        "links_to_online_documentation_and_other_useful_materials": "Links to online documentation and other useful materials",
    },
    "dataset_file": {
        "dataset_series": "Google Cloud Platform BigQuery Table Name",
        "file_path_and_name": "File path and name",
        "file_format": "File Format",
        "column_seperator": "Column Seperator",
        "string_identifier": "String identifier",
        "file_description": "File description",
        "reference_period": "Reference period",
        "file_size": "File size",
        "file_size_unit": "File size unit",
        "is_code_list": "Is code list",
        "number_of_records": "Number of records",
        "is_this_file_one_of_a_sequence_to_be_appended_back_together": "Is this file one of a sequence to be appended back together?",
        "number_of_header_rows": "Number of header rows",
        "number_of_footer_rows": "Number of footer rows",
        "character_encoding": "Character encoding",
        "hash_value_for_checksum": "Hash value for checksum",
        "notes": "Notes",
    },
    "variables": {
        "dataset_series": "Google Cloud Platform BigQuery Table Name",
        "variable_name": "Variable name",
        "google_cloud_platform_compatible_variable_name": "Google Cloud Platform compatible variable name",
        "variable_label": "Variable label",
        "variable_description": "Variable description",
        "position_in_file": "Position in file",
        "personally_identifiable_information": "Personally Identifiable Information",
        "variable_data_type": "Variable Data Type",
        "gcp_data_type": "GCP Data Type",
        "variable_lengthprecision": "Variable length/precision",
        "variable_format": "Variable format",
        "is_primary_key": "Is Primary Key",
        "is_foreign_key": "Is Foreign Key",
        "foreign_key_file_name": "Foreign Key file name",
        "foreign_key_variable_name": "Foreign Key variable name",
        "nullability": "Nullability",
        "null_values_denoted_by": "Null values denoted by",
        "variable_constraints": "Variable constraints",
        "applicable_business_rules": "Applicable business rules",
        "is_this_a_code": "Is this a code?",
        "notes": "Notes",
    },
}
